{'' WORKING
stingray with:
uk1122 motor control
line following kit with hc165
one ping
memsic
compass
speaker

}

CON

_clkmode = xtal1 + pll16x
_xinfreq = 5_000_000
Resolution      = 8150 '<-- 8.15us            

'Commands
UpdateTonToff   = 1
IO_State        = 2
DutyOverRide    = 3
SyncPhase       = 44


'DutyModes
Duty_default    = 0 '<-- Can be anything other than 1 or 2             
Duty_100        = 1
Duty_0          = 2

'@@@@@@@@@@@@@---pins---############
'Memsic
MMxpin        =25
MMypin        =26
MMtpin        =27
'Compass
compassEnable =22
compassClock  =21
compassData   =23
'ping
PingPin       =24
'hc165
hc165SHLD     =20
hc165CLK      =19
hc165CLKINH   =18
hc165SER      =17
'xbee
xbeeDin       =0
xbeeDout      =0
xbeeRTS       =0
'speaker
speaker       =0
'uk1122
motorin1      =16
motorena      =15
motorin2      =14
motorcsa      =13
motorin3      =12
motorenb      =11
motorin4      =10
motorcsb      =9
'***********************pins***************************
                 
VAR
  long stack[100],stackb[200]
  byte DutyCycleA, DutyCycleB, period
  long distance,xbeeData,xbeetext
  long csavalue, csbvalue
  byte command
  long rawheading, CorrectHeading
  long Deg'compass
  long clk_scale 'compass
  long mmx, mmy, mmt
  long mmra, mmxt, mmyt 'memsic
  long ilf 'hb165


OBJ
'  motor       : "UK1122"
  Ser         : "FullDuplexSerial"             'cog1 started in XB (listed in this obj section fyi)
  MM2125      : "Memsic2125_v1.2"              'cog2
  HM55B       : "HM55B Compass Module Asm"     'cog3
  Calibrate   : "HM55B Compass Calibration"    'no cog
  PWM         : "PWM_32_V4.spin"               'cog4
  ping        : "ping.spin"                    'no cog
  pst         : "PST Debug LITE"               'no cog
'  XB          : "XBee_Object_2"                'no cog uses FDS cog
  hc165       : "165"                          'no cog
                                               'cog5 debug cog
                                               'cog6 get sensor data cog

pub start

  dira[motorin1..motorcsb]:=%11101110                  'motor pin output exceb csa/b
  DutyCycleA := DutyCycleB := 50
  outa[motorENA]:=1                                    'turn it on
  outa[motorENB]:=1                                    'turn it on
  period:=50
  PWM.Start                                            'sound and motor control
  pst.start(115_200,pst#DEFAULT)                       'debug
  cognew(dubug,@stack)                                 'debug
  cognew(get,@stackb)                                  'get most sensors
  dira[speaker]:=%1                                    'enable speaker
  brownout                                             'startup sound
  clk_scale := clkfreq / 500_000                       'set clk_scale based on system clock
  MM2125.start(MMxpin, MMypin)                         'Initialize Mx2125
  waitcnt(clkfreq/10 + cnt)                            'wait for things to settle
  MM2125.setlevel                                      'normalize position
  hc165.start(hc165SHLD,hc165CLK,hc165CLKINH,hc165SER) 'start line reader
  HM55B.start(compassEnable,compassClock,compassData)  'start compass
  repeat

    'ilf      := hc165.read
    {foward(50)
    waitcnt(clkfreq*2+cnt)
    allbreak
    backward(50)
    waitcnt(clkfreq*2+cnt)
    'allbreak

    case ilf
          %11111110:forward(50)
          %11111101:forward(70)
          %01111111:backward(50)
          %10111111:backward(70)
          %11111111:allbreak
          %11001111:customF(50,70)
          %11110011:customB(50,70)}



{PUB Startall


  pst.start(115_200,pst#DEFAULT)                       'debug
  cognew(dubug,@stack)                                 'debug

  DutyCycleA := DutyCycleB := 50
  period:=50
  clk_scale := clkfreq / 500_000                       'set clk_scale based on system clock
  dira[speaker]:=%1
  dira[motorin1..motorcsb]:=%11101110                  'output exceb csa/b

  MM2125.start(MMxpin, MMypin)                         'Initialize Mx2125
  waitcnt(clkfreq/10 + cnt)                            'wait for things to settle
  MM2125.setlevel                                      'assume at startup that the memsic2125 is level Note: This line is important for determining a deg
  HM55B.start(compassEnable,compassClock,compassData)  'start compass

  hc165.start(hc165SHLD,hc165CLK,hc165CLKINH,hc165SER)                 'for line reader

  outa[motorENA]:=1                                    'turn it on
  outa[motorENB]:=1                                    'turn it on
  PWM.Start                                            'motor control

  XB.start(xbeeDin,xbeeDout,0,9600)                    'XBee Comms - RX,TX, Mode, Baud
  XB.AT_Init                                           'Initialize for fast AT command use - 5 second delay to perform
  XB.AT_ConfigVal(string("ATMY"),$0)                   'Set MY address to 5
  XB.AT_ConfigVal(string("ATDL"),$0)                   'Set MY address to 5
  xb.RxFlush

  brownout

  cognew(get,@stackb)                                  'get data from all sensors

  mainloop




pub mainloop|a,l,r

  repeat
     case xbeedata
       1:
         repeat until xbeedata == 9
                PWM.Duty(speaker,50,6666)
                PWM.Duty(speaker,50,6556)
         pwm.duty(speaker,0,0)

       2:
         repeat until xbeedata == 9
                forwards(50)
       3:
         repeat until xbeedata == 9
                backwards(60)
       4:
         xb.str(string(13,"left:"))
         l:=xb.rxDec
         xb.str(string(13,"right:"))
         r:=xb.rxDec
         repeat until xbeedata == 9
           customf(l,r)
       5:
         repeat until xbeedata == 9
           debugxb

     if distance <41
         allbreak
         PWM.Duty(speaker,50,2666)
         waitcnt(clkfreq/2+cnt)
         PWM.Duty(speaker,50,2006)
         waitcnt(clkfreq/20+cnt)
         pwm.duty(speaker,0,0)

     case ilf
          %11111110:forwards(50)
          %11111101:forwards(70)
          %01111111:backwards(50)
          %10111111:backwards(70)
          %11111111:allbreak
          %11001111:customF(50,70)
          %11110011:customB(50,70)}

pub backward(ds)

 DutyCycleA := DutyCycleB := ds   '50-100
 PWM.Duty(motorIN1, DutyCycleA, period)        ' Adjust motor speeds
 PWM.Duty(motorIN4, DutyCycleB, period)

pub customB(dca,dcb)
dutycyclea:=dca
dutycycleb:=dcb
 PWM.Duty(motorIN1, dutycycleA, period)        ' Adjust motor speeds
 PWM.Duty(motorIN4, dutycycleB, period)

pub customF(dca,dcb)
dutycyclea:=dca
dutycycleb:=dcb
 PWM.Duty(motorIN2, dutycycleA, period)        ' Adjust motor speeds
 PWM.Duty(motorIN3, dutycycleB, period)
  
pub forward(ds)

 DutyCycleA := DutyCycleB := ds
 PWM.Duty(motorIN2, DutyCycleA, period)        ' Adjust motor speeds
 PWM.Duty(motorIN3, DutyCycleB, period)
 


pub allbreak
 dutycyclea:=dutycycleb:=0
 PWM.Duty(motorIN1, 0, 0)        ' Adjust motor speeds
 PWM.Duty(motorIN4, 0, 0)
 PWM.Duty(motorIN2, 0, 0)        ' Adjust motor speeds
 PWM.Duty(motorIN3, 0, 0) 




pub brownout

  PWM.Duty(speaker,50,16666)                           'start sound - brownout detect
  waitcnt(clkfreq/2+cnt)
  PWM.Duty(speaker,50,6666)
  waitcnt(clkfreq/2+cnt)
  pwm.duty(speaker,0,0)

PUB dubug

  repeat
    pst.ListHome
    pst.Vars(@DutyCycleA, String("byte DutyCycleA, DutyCycleB, period"))
    pst.Vars(@distance, String("long distance,xbeedata,xbeetext"))
    pst.Vars(@csavalue, String("long CSAvalue,CSBvalue"))
    pst.Vars(@deg, String("long Deg"))
    pst.Vars(@mmra, String("long mmra,mmxt,mmyt"))
    'pst.Vars(@ilf, String("long ilf"))
    pst.Position(26, 17)
    pst.bin(ilf,8)

{
PUB debugxbi

    xb.str(string(13,"ppdb data",13,"lines:"))
    xb.bin(ilf,8)
    xb.str(string(13,"mm:"))
    xb.dec(distance)
}
pub get

 repeat

    'xbeedata := xb.rxDECtime(100)
    distance := ping.Millimeters(PINGPin)
    'ilf      := hc165.read 'unable to run in same cog? why?
    mmx      := MM2125.Mx            'get RAW x value
    mmy      := MM2125.My            'get RAW y value
    mmra     := MM2125.ro            'Get raw value for acceleration
    mmra     := mmra / clk_scale     'convert raw acceleration value to mg's
    mmt      := MM2125.theta         'Get raw 32-bit deg
    mmt      := mmt >> 24            'scale 32-bit value to an 8-bit Binary Radian
    mmt      := (mmt * 45)/32        'Convert Binary radians into Degrees
    mmxt     := MM2125.MxTilt
    mmyt     := MM2125.MyTilt

    RawHeading     := HM55B.Theta                     ' Read RAW 13-bit Angle
    CorrectHeading := Calibrate.Correct(RawHeading)   ' Calibrate Correct Heading
    Deg            := CorrectHeading * 45 / 1024      ' Convert 13-Bit Angle to Deg
                                                      ' Note: This only makes it easier for us Humans to read
    'csavalue:=ina[motorcsa]  'need ADC?
    'csbvalue:=ina[motorcsb]
    'if xbeedata <> 0
     '  repeat until xbeedata == 0
      '   xbeedata:=xb.rxDEC
    ilf      := hc165.read 'unable to run in same cog? why?
